#
# Various utility functions, mostly dealing with time
#

#
# Do a topological sort of an array.
# Based on having a block return the children of the node yield'ed to it, and
# passing an array in to tsort.
#
def tsort(array, &block)
	already_seen = {}
	giveable = []
	begin
		changed = nil
		array.each { |entry|
			next if already_seen[entry]
			goodchild = true
			children = yield entry
			children.each { |child| goodchild = nil unless already_seen[child] }
			block.call(entry).each { |child| goodchild = nil unless already_seen[child] }
			if (goodchild)
				giveable.push(entry)
				already_seen[entry] = true
				changed = true
			end
		}
	end while changed
	return giveable
end
